<?php


namespace Hector68\PrestaLiveInform\fabric;


use Hector68\PrestaLiveInform\install\AbstractInstaller;

abstract class InstallFabric
{

    protected $module;

    protected $install;

    /**
     * InstallFabric constructor.
     * @param $module
     */
    public function __construct($module)
    {
        $this->module = $module;
    }

    /**
     * @return mixed
     */
    public function getModule()
    {
        return $this->module;
    }


    /**
     * @return AbstractInstaller
     */
    abstract function getInstall();


    /**
     * @param $version
     * @param \Module $module
     * @return InstallFabric
     */
    public static function getInstance($version, \Module $module)
    {
        if (version_compare($version, '1.6', '<')) {
            return new Prestashop15Fabric($module);
        } elseif (version_compare($version, '1.7', '>=')) {
            return new Prestashop17Fabric($module);
        } else {
            return new Prestashop16Fabric($module);
        }
    }


}